using System.Collections.Generic;
using System.Xml.Serialization;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
	public partial class HbmArray
	{
	

		public string Name
		{
			get { return name; }
		}

		public string Access
		{
			get { return access; }
		}

		public bool IsLazyProperty
		{
			get { return false; }
		}

		public bool OptimisticLock
		{
			get { return optimisticlock; }
		}

	
		public string Cascade
		{
			get { return cascade; }
		}

	
		protected HbmMeta[] Metadatas
		{
			get { return meta ?? new HbmMeta[0]; }
		}

		public HbmLoader SqlLoader
		{
			get { return loader; }
		}

		public HbmCustomSQL SqlInsert
		{
			get { return sqlinsert; }
		}

		public HbmCustomSQL SqlUpdate
		{
			get { return sqlupdate; }
		}

		public HbmCustomSQL SqlDelete
		{
			get { return sqldelete; }
		}

		public HbmCustomSQL SqlDeleteAll
		{
			get { return sqldeleteall; }
		}


		public bool Inverse
		{
			get { return inverse; }
		}

		public bool Mutable
		{
			get { return mutable; }
		}

		public string OrderBy
		{
			get { return null; }
		}

		public string Where
		{
			get { return @where; }
		}

		public int? BatchSize
		{
			get { return batchsizeSpecified ? batchsize : (int?)null; }
		}

		public string PersisterQualifiedName
		{
			get { return persister; }
		}

		public string CollectionType
		{
			get { return collectiontype; }
		}

		public HbmCollectionFetchMode? FetchMode
		{
			get { return fetchSpecified ? (HbmCollectionFetchMode?) fetch : null; }
		}

		public HbmOuterJoinStrategy? OuterJoin
		{
			get { return outerjoinSpecified ? (HbmOuterJoinStrategy?) outerjoin : null; }
		}

		public HbmCollectionLazy? Lazy
		{
			get { return null; }
		}

		public string Table
		{
			get { return table; }
		}

		public string Schema
		{
			get { return schema; }
		}

		public string Catalog
		{
			get { return catalog; }
		}

		public string Check
		{
			get { return check; }
		}

		public object ElementRelationship
		{
			get { return Item1; }
		}

		public string Sort
		{
			get { return null; }
		}

		public bool? Generic
		{
			get { return null; }
		}

		[XmlIgnore]
		public IEnumerable<HbmFilter> Filters
		{
			get { yield break; }
		}

		public HbmKey Key
		{
			get { return key; }
		}

		public HbmCache Cache
		{
			get { return cache; }
		}

		public HbmListIndex ListIndex
		{
			get { return Item as HbmListIndex; }
		}

		public HbmIndex Index
		{
			get { return Item as HbmIndex; }
		}

	}
}