using System;
using System.Collections.Generic;
using System.Linq;
using System.Xml.Serialization;
using System.Reflection;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
    public partial class HbmComponent : TableResident
	{
        public HbmComponent(PropertyHelper propertyInfo) : this()
        {
            this.name = propertyInfo.Name;
            this.@class = MappingUtils.getStringClassDef(propertyInfo.PropertyType);
            Type targetType = propertyInfo.PropertyType;
            if(!MappingUtils.isEmbeddable(targetType))
            {
                throw new PersistenceException("Property <" + this.name + "> was anotated as Embedded but it's type <" + targetType.FullName + "> is not anotated as Embeddable");
            }
            List<object> itemsList = new List<object>();
            ClassUtils.mapProperties(targetType, propertyInfo, itemsList, null, null, false);
            this.Items = itemsList.ToArray();
        }

        public String getTable()
        {
            foreach (Object item in this.Items)
            {
                if (item is TableResident)
                {
                    return ((TableResident)item).getTable();
                }
            }
            return null;
        }
    }
}