﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NPersistence.NHibernate.annotationSupport.mapping
{
    partial class HbmResultSet
    {
        public HbmResultSet(SqlResultSetMapping resSet, IEnumerable<EntityResult> entities, IEnumerable<ColumnResult> columns, object[] fieldResultArr)
            : this()
        {
            this.name = resSet.Name;
            List<object> itemsList = new List<object>();
            // handle scalar
            foreach (ColumnResult col in columns)
            {
                if(col.Type == null)
                {
                    throw new PersistenceException("ColumnResult.Type can't be null");
                }
                itemsList.Add(new HbmReturnScalar 
                {
                    column = col.Name,
                    type = col.Type
                });
            }

            //handle Entities
            foreach (EntityResult entity in entities)
            {
                IEnumerable<FieldResult> fieldResults =
                        from fieldRes in fieldResultArr
                        where ((FieldResult)fieldRes).EntityRef.Equals(entity.Name)
                        select (FieldResult)fieldRes;
                itemsList.Add(new HbmReturn(entity, fieldResults));
            }
            this.Items = itemsList.ToArray();
        }

       
    }
}
