
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NPersistence.spi;
using System.Xml;

namespace NPersistence.NHibernate.packaging
{
    public class XmlHelper
    {
        public static String PERSISTENCE_UNIT = "persistence-unit";
        public static String getElementContent(XmlNode element)
        {
            return getElementContent(element, null);
        }

        /**
        * Get the content of the given element.
        *
        * @param element	The element to get the content for.
        * @param defaultStr The default to return when there is no content.
        * @return The content of the element or the default.
        */
        public static String getElementContent(XmlNode element, String defaultStr)
        {
            if (element == null)
            {
                return defaultStr;
            }
            StringBuilder result = new StringBuilder("");
            XmlNodeList children = element.ChildNodes;
            foreach (XmlNode childNode in children)
            {
                if (childNode.NodeType == XmlNodeType.Text || childNode.NodeType == XmlNodeType.CDATA)
                {
                    result.Append(childNode.Value);
                }
            }
            return result.ToString().Trim();
        }

        public static Dictionary<string, string> getAttributeMapping(XmlAttributeCollection attributes)
        {
            Dictionary<string, string> attributeMap = new Dictionary<string, string>();
            foreach (XmlAttribute attr in attributes)
            {
                attributeMap.Add(attr.Name, attr.Value);
            }
            return attributeMap;
        }

    }
}


